Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules
## Summary Coraza extracts a multipart file upload's filename using Go's standard-library `mime.ParseMediaType`, which only decodes the RFC 5987/6266 extended `filename*` `Content-Disposition` parameter when its declared charset is exactly `us-ascii` or `utf-8`. Any other charset — including `iso-8859-1`, which RFC 5987 explicitly permits — is silently dropped by the stdlib, with no error and no fallback signal. This lets an attacker present one filename to Coraza and a different one to the backend application in the same request. ## Affected variables `FILES` (documented as *"the original filenames as submitted by the client in the multipart upload"*), `FILES_SIZES`, and the file-vs-field routing decision that determines whether a part is tracked as a file at all. `MULTIPART_FILENAME` is not affected. It is declared in Coraza but is not populated by any code path in the affected versions. ## Details `internal/bodyprocessors/multipart.go`'s `originFileName` calls `mime.ParseMediaType` on the raw `Content-Disposition` header and reads `dispositionParams["filename"]`, which then populates `FILES`/`FILES_SIZES` for parts recognized as file uploads. Per RFC 7578 §4.2 and RFC 6266, when both `filename` and `filename*` are present, `filename*` is authoritative. Go's `mime.ParseMediaType` implements this precedence internally (`decode2231Enc` in `mediatype.go`), but only for `filename*` values whose charset token is `us-ascii` or `utf-8`: ```go // mime/mediatype.go if charset != "us
- Products
- github.com/corazawaf/coraza, github.com/corazawaf/coraza/v2, github.com/corazawaf/coraza/v3
- Affected versions
- Not specified
- Fixed versions
- 3.8.1
- CVEs
- CVE-2026-114101
- Confirmed fixed CVEs
- Not specified
- Updated in this feed
- 31 Oct 2026, 14:08 UTC · Revision 2
Source evidence
Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules
core-osv · Original sourcePublished 8 Oct 2026, 17:51 UTC
## Summary Coraza extracts a multipart file upload's filename using Go's standard-library `mime.ParseMediaType`, which only decodes the RFC 5987/6266 extended `filename*` `Content-Disposition` parameter when its declared charset is exactly `us-ascii` or `utf-8`. Any other charset — including `iso-8859-1`, which RFC 5987 explicitly permits — is silently dropped by the stdlib, with no error and no fallback signal. This lets an attacker present one filename to Coraza and a different one to the backend application in the same request. ## Affected variables `FILES` (documented as *"the original filenames as submitted by the client in the multipart upload"*), `FILES_SIZES`, and the file-vs-field routing decision that determines whether a part is tracked as a file at all. `MULTIPART_FILENAME` is not affected. It is declared in Coraza but is not populated by any code path in the affected versions. ## Details `internal/bodyprocessors/multipart.go`'s `originFileName` calls `mime.ParseMediaType` on the raw `Content-Disposition` header and reads `dispositionParams["filename"]`, which then populates `FILES`/`FILES_SIZES` for parts recognized as file uploads. Per RFC 7578 §4.2 and RFC 6266, when both `filename` and `filename*` are present, `filename*` is authoritative. Go's `mime.ParseMediaType` implements this precedence internally (`decode2231Enc` in `mediatype.go`), but only for `filename*` values whose charset token is `us-ascii` or `utf-8`: ```go // mime/mediatype.go if charset != "us
osv:GHSA-3wr7-993q-jrff
github.com/corazawaf/coraza/v3
Fixed versions: 3.8.1
Complete source record
{
"id": "ca62fe101455b131025fa9f08c2b3e803573d69b60bdbf5fb51c2dffde052b1f",
"url": "https://osv.dev/vulnerability/GHSA-3wr7-993q-jrff",
"method": "structured",
"payload": {
"kind": "advisory",
"title": "Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules",
"summary": "## Summary Coraza extracts a multipart file upload's filename using Go's standard-library `mime.ParseMediaType`, which only decodes the RFC 5987/6266 extended `filename*` `Content-Disposition` parameter when its declared charset is exactly `us-ascii` or `utf-8`. Any other charset — including `iso-8859-1`, which RFC 5987 explicitly permits — is silently dropped by the stdlib, with no error and no fallback signal. This lets an attacker present one filename to Coraza and a different one to the backend application in the same request. ## Affected variables `FILES` (documented as *\"the original filenames as submitted by the client in the multipart upload\"*), `FILES_SIZES`, and the file-vs-field routing decision that determines whether a part is tracked as a file at all. `MULTIPART_FILENAME` is not affected. It is declared in Coraza but is not populated by any code path in the affected versions. ## Details `internal/bodyprocessors/multipart.go`'s `originFileName` calls `mime.ParseMediaType` on the raw `Content-Disposition` header and reads `dispositionParams[\"filename\"]`, which then populates `FILES`/`FILES_SIZES` for parts recognized as file uploads. Per RFC 7578 §4.2 and RFC 6266, when both `filename` and `filename*` are present, `filename*` is authoritative. Go's `mime.ParseMediaType` implements this precedence internally (`decode2231Enc` in `mediatype.go`), but only for `filename*` values whose charset token is `us-ascii` or `utf-8`: ```go // mime/mediatype.go if charset != \"us",
"evidence": "osv:GHSA-3wr7-993q-jrff",
"products": [
{
"name": {
"value": "github.com/corazawaf/coraza/v3",
"evidence": "/affected/0/package/name"
},
"prerequisites": [],
"fixed_versions": [
{
"value": "3.8.1",
"evidence": "/affected/0/ranges"
}
],
"affected_versions": []
}
],
"severity": "medium",
"structured": {
"id": "GHSA-3wr7-993q-jrff",
"aliases": [
"CVE-2026-114101",
"GHSA-3wr7-993q-jrff",
"GO-2026-6691"
],
"metrics": [
{
"type": "CVSS_V3",
"score": "CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:L/A:N"
}
],
"affected": [
{
"ranges": [
{
"type": "SEMVER",
"events": [
{
"introduced": "0"
},
{
"fixed": "3.8.1"
}
]
}
],
"package": {
"name": "github.com/corazawaf/coraza/v3",
"purl": "pkg:golang/github.com/corazawaf/coraza/v3",
"ecosystem": "Go"
},
"database_specific": {
"source": "https://github.com/github/advisory-database/blob/main/advisories/github-reviewed/2026/10/GHSA-3wr7-993q-jrff/GHSA-3wr7-993q-jrff.json"
}
}
],
"modified": "2026-10-21T10:57:00.041974308Z",
"provider": "osv",
"references": [
"https://github.com/corazawaf/coraza/security/advisories/GHSA-3wr7-993q-jrff",
"https://github.com/corazawaf/coraza/commit/5427c501b2fea6ae1305903efef01b3049224a58",
"https://github.com/corazawaf/coraza/commit/b2a9264437116bdd98a86fe345b2aec1152d3d7c",
"https://github.com/corazawaf/coraza/commit/cae3c7407e7b84372c207033de03f15f89bf351a",
"https://github.com/corazawaf/coraza",
"https://github.com/corazawaf/coraza/releases/tag/v3.8.1"
],
"provider_metadata": {
"cwe_ids": [
"CWE-20",
"CWE-436"
],
"severity": "MODERATE",
"github_reviewed": true,
"nvd_published_at": null,
"github_reviewed_at": "2026-10-08T17:51:36Z"
}
},
"related_cves": [
{
"value": "CVE-2026-114101",
"evidence": "/aliases"
}
],
"security_relevant": true,
"severity_evidence": "/severity/0/score"
},
"source_id": "core-osv",
"document_id": 392969,
"published_at": "2026-10-08T17:51:36+00:00"
}Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules in github.com/corazawaf/coraza
core-osv · Original sourcePublished 19 Oct 2026, 21:08 UTC
Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules in github.com/corazawaf/coraza
osv:GO-2026-6691
github.com/corazawaf/coraza
Fixed versions: Not specified
github.com/corazawaf/coraza/v2
Fixed versions: Not specified
github.com/corazawaf/coraza/v3
Fixed versions: 3.8.1
Complete source record
{
"id": "9b71004126bd6b2df3b555d71c54d097fa135c485976b7166b53c1fa74b5abfe",
"url": "https://osv.dev/vulnerability/GO-2026-6691",
"method": "structured",
"payload": {
"kind": "advisory",
"title": "Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules in github.com/corazawaf/coraza",
"summary": "Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules in github.com/corazawaf/coraza",
"evidence": "osv:GO-2026-6691",
"products": [
{
"name": {
"value": "github.com/corazawaf/coraza",
"evidence": "/affected/0/package/name"
},
"prerequisites": [],
"fixed_versions": [],
"affected_versions": []
},
{
"name": {
"value": "github.com/corazawaf/coraza/v2",
"evidence": "/affected/1/package/name"
},
"prerequisites": [],
"fixed_versions": [],
"affected_versions": []
},
{
"name": {
"value": "github.com/corazawaf/coraza/v3",
"evidence": "/affected/2/package/name"
},
"prerequisites": [],
"fixed_versions": [
{
"value": "3.8.1",
"evidence": "/affected/2/ranges"
}
],
"affected_versions": []
}
],
"severity": "unknown",
"structured": {
"id": "GO-2026-6691",
"aliases": [
"CVE-2026-114101",
"GHSA-3wr7-993q-jrff",
"GO-2026-6691"
],
"affected": [
{
"ranges": [
{
"type": "SEMVER",
"events": [
{
"introduced": "0"
}
]
}
],
"package": {
"name": "github.com/corazawaf/coraza",
"purl": "pkg:golang/github.com/corazawaf/coraza",
"ecosystem": "Go"
},
"database_specific": {
"source": "https://vuln.go.dev/ID/GO-2026-6691.json"
},
"ecosystem_specific": {}
},
{
"ranges": [
{
"type": "SEMVER",
"events": [
{
"introduced": "0"
}
]
}
],
"package": {
"name": "github.com/corazawaf/coraza/v2",
"purl": "pkg:golang/github.com/corazawaf/coraza/v2",
"ecosystem": "Go"
},
"database_specific": {
"source": "https://vuln.go.dev/ID/GO-2026-6691.json"
},
"ecosystem_specific": {}
},
{
"ranges": [
{
"type": "SEMVER",
"events": [
{
"introduced": "0"
},
{
"fixed": "3.8.1"
}
]
}
],
"package": {
"name": "github.com/corazawaf/coraza/v3",
"purl": "pkg:golang/github.com/corazawaf/coraza/v3",
"ecosystem": "Go"
},
"database_specific": {
"source": "https://vuln.go.dev/ID/GO-2026-6691.json"
},
"ecosystem_specific": {}
}
],
"modified": "2026-10-21T10:57:00.041974308Z",
"provider": "osv",
"references": [
"https://github.com/corazawaf/coraza/security/advisories/GHSA-3wr7-993q-jrff",
"https://github.com/corazawaf/coraza/commit/5427c501b2fea6ae1305903efef01b3049224a58",
"https://github.com/corazawaf/coraza/commit/b2a9264437116bdd98a86fe345b2aec1152d3d7c",
"https://github.com/corazawaf/coraza/commit/cae3c7407e7b84372c207033de03f15f89bf351a",
"https://github.com/corazawaf/coraza/releases/tag/v3.8.1"
],
"provider_metadata": {
"url": "https://pkg.go.dev/vuln/GO-2026-6691",
"review_status": "UNREVIEWED"
}
},
"related_cves": [
{
"value": "CVE-2026-114101",
"evidence": "/aliases"
}
],
"security_relevant": true,
"severity_evidence": null
},
"source_id": "core-osv",
"document_id": 392970,
"published_at": "2026-10-19T21:08:17+00:00"
}